Index: s390-tools-sles11/zconf/znetcontrolunits
===================================================================
--- /dev/null
+++ s390-tools-sles11/zconf/znetcontrolunits
@@ -0,0 +1,53 @@
+#!/bin/bash
+#
+# znetcontrolunits - define some common control unit mappings
+#
+# This definitions are not intended to be used as standalone tool, but should be
+# used from other tools like a library. E.g. znetconf is one exploiter
+# of them.
+#
+# Copyright (C) IBM Corp. 2008, 2009
+# Author: Steffen Maier <maier@de.ibm.com>
+#
+
+# The arrays (among other things) should be adapted, if any of those device
+# drivers start supporting different CU types/models.
+
+readonly -a CU=(
+    1731/01
+    1731/05
+    3088/08
+    3088/1f
+    3088/1e
+    3088/01
+    3088/60
+    3088/61
+    1731/06
+)
+
+readonly -a CU_DEVDRV=(
+    qeth
+    qeth
+    ctcm
+    ctcm
+    ctcm
+    lcs
+    lcs
+    lcs
+    qeth
+)
+
+# Searches for a match of argument 1 on the array $CU and sets $cu_idx
+# to the matched array index on success.
+# Returns 0 on success, 1 on failure.
+function search_cu() {
+    local scu=$1
+    local i
+    for ((i=0; i < ${#CU[@]}; i++)); do
+        if [ "$scu" == "${CU[i]}" ]; then
+            cu_idx=$i
+            return 0
+        fi
+    done
+    return 1
+}
Index: s390-tools-sles11/zfcpdump_v2/zfcpdump.c
===================================================================
--- s390-tools-sles11.orig/zfcpdump_v2/zfcpdump.c
+++ s390-tools-sles11/zfcpdump_v2/zfcpdump.c
@@ -339,7 +339,15 @@ static int umount_dump_device(void)
  */
 static void terminate(void)
 {
+	int fd;
+
 	sleep(WAIT_TIME_END); /* give the messages time to be displayed */
+	fd = open(DEV_ZCORE_REIPL, O_WRONLY, 0);
+	if (fd == -1)
+		goto no_reipl;
+	write(fd, REIPL, 1);
+	close(fd);
+no_reipl:
 	reboot(LINUX_REBOOT_CMD_POWER_OFF);
 }
 
Index: s390-tools-sles11/zfcpdump_v2/zfcpdump.h
===================================================================
--- s390-tools-sles11.orig/zfcpdump_v2/zfcpdump.h
+++ s390-tools-sles11/zfcpdump_v2/zfcpdump.h
@@ -77,6 +77,8 @@ struct globals {
 #define PROC_MISC	"/proc/misc"
 #define DEV_ZCORE	"/sys/kernel/debug/zcore/mem"
 #define DEV_ZCORE_MAP	"/sys/kernel/debug/zcore/memmap"
+#define DEV_ZCORE_REIPL	"/sys/kernel/debug/zcore/reipl"
+#define REIPL		"1"
 #define DEV_SCSI	"/dev/sda"
 #define DUMP_DIR	"/mnt"
 
Index: s390-tools-sles11/ziomon/Makefile
===================================================================
--- s390-tools-sles11.orig/ziomon/Makefile
+++ s390-tools-sles11/ziomon/Makefile
@@ -3,21 +3,36 @@ include ../common.mak
 
 #CFLAGS+=-Wall -Wundef -Wstrict-prototypes -Wno-trigraphs -g -I../include
 CFLAGS+=-Wall -Wundef -Wstrict-prototypes -Wno-trigraphs -DNDEBUG -O3 -I../include
+#CFLAGS+=-Wall -Wundef -Wstrict-prototypes -Wno-trigraphs -g -O3 -I../include
+#CXXFLAGS+=-Wall -Wundef -Wno-trigraphs -g -I../include
+CXXFLAGS+=-Wall -Wundef -Wno-trigraphs -DNDEBUG -O3 -I../include
+#CXXFLAGS+=-Wall -Wundef -Wno-trigraphs -g -O3 -I../include
 
-all: ziomon_util ziomon_mgr ziomon_zfcpdd
+TARGETS = ziomon_util ziomon_mgr ziomon_zfcpdd ziorep_utilization ziorep_traffic
+
+all: $(TARGETS)
 
 ziomon_mgr: ziomon_dacc.o ziomon_util.o ziomon_mgr.c ziomon_tools.o ziomon_zfcpdd.o ziomon_msg_tools.o
-	$(CC) -DWITH_MAIN $(CFLAGS) ziomon_mgr.c ziomon_dacc.o ziomon_tools.o ziomon_util.o ziomon_zfcpdd.o ziomon_msg_tools.o -o $@
+	$(CC) -DWITH_MAIN $(CFLAGS) -lm $^ -o $@
 
 ziomon_util: ziomon_util.c ziomon_util.h ziomon_tools.o
-	$(CC) -DWITH_MAIN $(CFLAGS) ziomon_tools.o $< -o $@
+	$(CC) -DWITH_MAIN $(CFLAGS) ziomon_tools.o -lm $< -o $@
 
 ziomon_zfcpdd: ziomon_zfcpdd.c ziomon_zfcpdd.h ziomon_tools.o
-	$(CC) -DWITH_MAIN $(CFLAGS) ziomon_tools.o -lrt $< -o $@
+	$(CC) -DWITH_MAIN $(CFLAGS) ziomon_tools.o -lm -lrt $< -o $@
+
+ziorep_traffic: ziorep_traffic.cpp ziorep_framer.o ziorep_frameset.o ziorep_printers.o ziomon_dacc.o ziomon_util.o ziomon_msg_tools.o ziomon_tools.o ziomon_zfcpdd.o ziorep_cfgreader.o ziorep_collapser.o ziorep_utils.o ziorep_filters.o
+	$(CXX) $(CXXFLAGS) $^ -o $@
+
+ziorep_utilization: ziorep_utilization.cpp ziorep_framer.o ziorep_frameset.o ziorep_printers.o ziomon_dacc.o ziomon_util.o ziomon_msg_tools.o ziomon_tools.o ziomon_zfcpdd.o ziorep_cfgreader.o ziorep_collapser.o ziorep_utils.o ziorep_filters.o
+	$(CXX) $(CXXFLAGS) $^ -o $@
 
 %.o: %.c
 	$(CC) $(CFLAGS) -c $<
 
+%.o: %.cpp
+	$(CXX) $(CXXFLAGS) -c $<
+
 install: all
 	cat ziomon  | sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' > $(BINDIR)/ziomon;
 	chown $(OWNER).$(GROUP) $(BINDIR)/ziomon;
@@ -25,6 +40,9 @@ install: all
 	cat ziomon_fcpconf  | sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' > $(BINDIR)/ziomon_fcpconf;
 	chown $(OWNER).$(GROUP) $(BINDIR)/ziomon_fcpconf;
 	chmod 755 $(BINDIR)/ziomon_fcpconf;
+	cat ziorep_config  | sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' > $(BINDIR)/ziorep_config;
+	chown $(OWNER).$(GROUP) $(BINDIR)/ziorep_config;
+	chmod 755 $(BINDIR)/ziorep_config;
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziomon.8 $(MANDIR)/man8
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziomon_fcpconf.8 $(MANDIR)/man8
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ziomon_util $(BINDIR)
@@ -33,6 +51,11 @@ install: all
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziomon_mgr.8 $(MANDIR)/man8
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ziomon_zfcpdd $(BINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziomon_zfcpdd.8 $(MANDIR)/man8
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziorep_config.8 $(MANDIR)/man8
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ziorep_utilization $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziorep_utilization.8 $(MANDIR)/man8
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ziorep_traffic $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziorep_traffic.8 $(MANDIR)/man8
 
 uninstall:
 	rm $(BINDIR)/ziomon
@@ -40,11 +63,17 @@ uninstall:
 	rm $(BINDIR)/ziomon_mgr
 	rm $(BINDIR)/ziomon_zfcpdd
 	rm $(BINDIR)/ziomon_fcpconf
+	rm $(BINDIR)/ziorep_config
+	rm $(BINDIR)/ziorep_utilization
+	rm $(BINDIR)/ziorep_traffic
 	rm $(MANDIR)/man8/ziomon.8*
 	rm $(MANDIR)/man8/ziomon_util.8*
 	rm $(MANDIR)/man8/ziomon_mgr.8*
 	rm $(MANDIR)/man8/ziomon_zfcpdd.8*
 	rm $(MANDIR)/man8/ziomon_fcpconf.8*
+	rm $(MANDIR)/man8/ziorep_config.8*
+	rm $(MANDIR)/man8/ziorep_utilization.8*
+	rm $(MANDIR)/man8/ziorep_traffic.8*
 
 clean:
-	-rm -f ziomon_util ziomon_mgr ziomon_dacc.o ziomon_dacc.o check_integrity ziomon_util.o ziomon_zfcpdd ziomon_zfcpdd.o ziomon_tools.o ziomon_msg_tools.o
+	-rm -f *.o $(TARGETS)
Index: s390-tools-sles11/ziomon/blkiomon.h
===================================================================
--- s390-tools-sles11.orig/ziomon/blkiomon.h
+++ s390-tools-sles11/ziomon/blkiomon.h
@@ -19,29 +19,26 @@
 #define BLKIOMON_D2C_BUCKETS 25
 struct blkiomon_stat {
 	__u64 time;
+	/* Histogram of request sizes in Bytes.
+	   Step-size is 1024, starting at 0. */
 	__u32 size_hist[BLKIOMON_SIZE_BUCKETS];
+	/* Histogram of dispatch to completion request times in u-secs.
+	   Step-size is 8, starting at 0. */
 	__u32 d2c_hist[BLKIOMON_D2C_BUCKETS];
-	struct minmax size_r;
-	struct minmax size_w;
-	struct minmax d2c_r;
-	struct minmax d2c_w;
-	struct minmax thrput_r;
-	struct minmax thrput_w;
-	__u64 bidir;
-	__u32 device;
+	struct minmax size_r;	/* stats of read request sizes in Bytes */
+	struct minmax size_w;	/* stats of write request sizes in Bytes */
+	struct minmax d2c_r;	/* stats of read request durations in u-secs */
+	struct minmax d2c_w;	/* stats of write request durations in u-secs */
+	struct minmax thrput_r;	/* stats of read throughput in Kbytes per micro-sec */
+	struct minmax thrput_w;	/* stats of write throughput in Kbytes per micro-sec */
+	__u64 bidir;	/* number of bi-directional requests, is set exclusive
+			(ie. not implicitly adding 1 to rd and wrt as well) */
+	__u32 device;	/* device identifier */
 } __attribute__ ((packed));
 
-static struct histlog2 size_hist = {
-	.first = 0,
-	.delta = 1024,
-	.num = BLKIOMON_SIZE_BUCKETS
-};
-
-static struct histlog2 d2c_hist = {
-	.first = 0,
-	.delta = 8,
-	.num = BLKIOMON_D2C_BUCKETS
-};
+static struct histlog2 size_hist = {0, 1024, BLKIOMON_SIZE_BUCKETS};
+
+static struct histlog2 d2c_hist = {0, 8, BLKIOMON_D2C_BUCKETS};
 
 static inline void blkiomon_stat_init(struct blkiomon_stat *bstat)
 {
@@ -78,8 +75,10 @@ static inline void blkiomon_conv_from_BE
 }
 
 static inline void blkiomon_stat_merge(struct blkiomon_stat *dst,
-				       struct blkiomon_stat *src)
+				       const struct blkiomon_stat *src)
 {
+	if (src->device != dst->device)
+		dst->device = 0xffffffff;
 	if (src->time > dst->time)
 		dst->time = src->time;
 	histlog2_merge(&size_hist, dst->size_hist, src->size_hist);
@@ -98,12 +97,12 @@ static inline void blkiomon_stat_merge(s
 #define MAJOR(dev)	((unsigned int) ((dev) >> MINORBITS))
 #define MINOR(dev)	((unsigned int) ((dev) & MINORMASK))
 
-static inline void blkiomon_stat_print(struct blkiomon_stat *p)
+static inline void blkiomon_stat_print(const struct blkiomon_stat *p)
 {
 	time_t t = p->time;
 
-	printf("\ntime: %s", ctime(&t));
-	printf("device: %d,%d\n", MAJOR(p->device), MINOR(p->device));
+	printf("time: %s", ctime(&t));
+	printf("device: %d:%d\n", MAJOR(p->device), MINOR(p->device));
 	minmax_print("sizes read (bytes)", &p->size_r);
 	minmax_print("sizes write (bytes)", &p->size_w);
 	minmax_print("d2c read (usec)", &p->d2c_r);
Index: s390-tools-sles11/ziomon/stats.h
===================================================================
--- s390-tools-sles11.orig/ziomon/stats.h
+++ s390-tools-sles11/ziomon/stats.h
@@ -12,7 +12,9 @@
 #define STATS_H
 
 #include <linux/types.h>
-#include "endian.h"
+#include <endian.h>
+#include <stdio.h>
+#include <math.h>
 
 struct minmax {
 	__u64 min;
@@ -42,7 +44,7 @@ static inline void minmax_account(struct
 	mm->num++;
 }
 
-static inline void minmax_merge(struct minmax *dst, struct minmax *src)
+static inline void minmax_merge(struct minmax *dst, const struct minmax *src)
 {
 	dst->sum += src->sum;
 	dst->sos += src->sos;
@@ -62,25 +64,33 @@ static inline void minmax_swap(struct mi
 	swap_64(mm->num);
 }
 
-static inline double minmax_avg(struct minmax *mm)
+static inline double minmax_avg(const struct minmax *mm)
 {
 	return (mm->sum / (double)mm->num);
 }
 
-static inline double minmax_var(struct minmax *mm)
+static inline double minmax_var(const struct minmax *mm)
 {
 	double num = (double)mm->num;
 
 	return ((mm->sos - ((mm->sum * mm->sum) / num)) / num);
 }
 
-static inline int minmax_print(const char *s, struct minmax *mm)
+static inline double minmax_std_dev(const struct minmax *mm)
 {
-	return printf("%s: num %Ld, min %Ld, max %Ld, sum %Ld, squ %Ld, "
-		       "avg %.1f, var %.1f\n", s, (unsigned long long)mm->num,
+	return sqrt(minmax_var(mm));
+}
+
+static inline int minmax_print(const char *s, const struct minmax *mm)
+{
+	if (mm->num)
+		return printf("%s: num %Lu, min %Lu, max %Lu, sum %Lu, squ %Lu, "
+		       "avg %.1lf, std dev %.1lf\n", s, (unsigned long long)mm->num,
 		       (unsigned long long)mm->min, (unsigned long long)mm->max,
 		       (unsigned long long)mm->sum, (unsigned long long)mm->sos,
-		       minmax_avg(mm), minmax_var(mm));
+		       minmax_avg(mm), minmax_std_dev(mm));
+	else
+		return printf("%s: (none)\n", s);
 }
 
 struct histlog2 {
@@ -89,7 +99,7 @@ struct histlog2 {
 	int num;
 };
 
-static inline __u64 histlog2_upper_limit(int index, struct histlog2 *h)
+static inline __u64 histlog2_upper_limit(int index, const struct histlog2 *h)
 {
 	return h->first + (index ? h->delta << (index - 1) : 0);
 }
@@ -98,7 +108,7 @@ static inline int histlog2_index(__u64 v
 {
 	int i;
 
-	for (i = 0; i < (h->num - 1) && val > histlog2_upper_limit(i, h); i++);
+	for (i = 0; i < h->num && val > histlog2_upper_limit(i, h); i++);
 	return i;
 }
 
@@ -109,24 +119,25 @@ static inline void histlog2_account(__u3
 	bucket[index]++;
 }
 
-static inline void histlog2_merge(struct histlog2 *h, __u32 *dst, __u32 *src)
+static inline void histlog2_merge(struct histlog2 *h, __u32 *dst, const __u32 *src)
 {
 	int i;
 
-	for (i = 0; i < h->num - 1; i++)
+	for (i = 0; i < h->num; i++) {
 		dst[i] += src[i];
+	}
 }
 
 static inline void histlog2_swap(__u32 a[], struct histlog2 *h)
 {
 	int i;
 
-	for (i = 0; i < h->num - 1; i++)
+	for (i = 0; i < h->num; i++)
 		swap_32(a[i]);
 }
 
-static inline void histlog2_print(const char *s, __u32 a[],
-				  struct histlog2 *h)
+static inline void histlog2_print(const char *s, const __u32 a[],
+				  const struct histlog2 *h)
 {
 	int i;
 
Index: s390-tools-sles11/ziomon/ziomon
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon
+++ s390-tools-sles11/ziomon/ziomon
@@ -10,6 +10,7 @@
 # Author(s): Stefan Raspl <raspl@linux.vnet.ibm.com>
 #
 
+WRP_TOOLNAME="ziomon"
 WRP_MSG_Q_PATH="/tmp/.zfcpstats$RANDOM";
 WRP_MSG_Q_ID=1;
 WRP_MSG_Q_UTIL_ID=1;
@@ -31,7 +32,7 @@ WRP_DEVICES=();
 WRP_LUNS=();
 WRP_LOGFILE="";
 # limit of actual data in percent that need space on disk
-WRP_SIZE_THRESHOLD="25";
+WRP_SIZE_THRESHOLD="10";
 WRP_FORCE=0;
 
 function debug() {
@@ -73,7 +74,7 @@ function print_usage() {
 function check_for_int() {
    [ $1 -gt 0 ] >/dev/null 2>&1;
    if [ $? -ne 0 ]; then
-      echo "Error: $1 is not a valid argument to $2 - must be positive integer";
+      echo "$WRP_TOOLNAME: $1 is not a valid argument to $2 - must be positive integer";
       exit 3;
    fi
 }
@@ -107,7 +108,7 @@ function parse_size() {
       G) (( WRP_SIZE=1000*$size ));;
       M) WRP_SIZE=$size;;
       T) (( WRP_SIZE=1000000*$size ));;
-      *) echo "Error: Unknown size suffix $unit";
+      *) echo "$WRP_TOOLNAME: Unknown size suffix $unit";
          return 1;;
    esac;
 
@@ -152,7 +153,7 @@ function parse_params() {
                 print_version;
                 exit 1;;
             -*)
-                echo "ziomon: Invalid option -- $1";
+                echo "$WRP_TOOLNAME: Invalid option -- $1";
                 echo "Try 'ziomon --help' for more information.";
                 exit 1;;
             *)
@@ -162,22 +163,22 @@ function parse_params() {
         shift;
    done
    if [ ${#WRP_DEVICES[@]} -eq 0 ]; then
-      echo "Error: No devices specified!";
+      echo "$WRP_TOOLNAME: No devices specified";
       error=1;
    fi
    if [ "$WRP_LOGFILE" == "" ]; then
-      echo "Error: No logfile specified";
+      echo "$WRP_TOOLNAME: No logfile specified";
       error=1;
    fi
    if [ $error -eq 0 ] && [ `dirname $WRP_LOGFILE` == "" ]; then
       WRP_LOGFILE=$WRP_LOGFILE;
    fi
    if [ $error -eq 0 ] && [ ! -d `dirname $WRP_LOGFILE` ]; then
-      echo "Error: Directory `dirname $WRP_LOGFILE` does not exist.";
+      echo "$WRP_TOOLNAME: Directory `dirname $WRP_LOGFILE` does not exist";
       error=1;
    fi
    if [ "$WRP_DURATION" == "" ]; then
-      echo "Error: No duration specified - see option '-d'";
+      echo "$WRP_TOOLNAME: No duration specified - see option '-d'";
       error=1;
    fi
    [ $error -eq 0 ] && check_for_int $WRP_DURATION -d;
@@ -190,12 +191,12 @@ function parse_params() {
 
    tmp=`expr $WRP_INTERVAL % 2`;
    if [ $error -eq 0 ] && [ $tmp -ne 0 ]; then
-      echo "Error: The interval length must be an even number.";
+      echo "$WRP_TOOLNAME: The interval length must be an even number";
       error=1;
    fi
    tmp=`expr $WRP_DURATION % $WRP_INTERVAL`;
    if [ $error -eq 0 ] && [ $tmp -ne 0 ]; then
-      echo "Error: The duration must be a multiple of the interval length";
+      echo "$WRP_TOOLNAME: The duration must be a multiple of the interval length";
       error=1;
    fi
    if [ $error -ne 0 ]; then
@@ -213,11 +214,11 @@ function parse_params() {
 
 
 function check_for_process() {
-   if [ ! -d /proc/$1 ]; then
+   if [ $# -eq 0 ] || [ ! -d /proc/$1 ]; then
       echo "failed";
-      shutdown;
       return 1;
    fi
+
    return 0;
 }
 
@@ -233,6 +234,7 @@ function start_trace() {
    local hosts_param;
    local luns_param;
    local i;
+   local len;
 
    if [ $WRP_DEBUG -ne 0 ]; then
       verbose="-V";
@@ -275,7 +277,7 @@ function start_trace() {
    blkiomon_command="blkiomon --interval=$WRP_INTERVAL -Q  $WRP_MSG_Q_PATH -q $WRP_MSG_Q_ID -m $WRP_MSG_Q_BLKIOMON_ID $verbose_blk -d -";
    zfcpdd_command="ziomon_zfcpdd -Q  $WRP_MSG_Q_PATH -q $WRP_MSG_Q_ID -m $WRP_MSG_Q_ZIOMON_ZFCPDD_ID -i $WRP_INTERVAL";
    debug "starting blktrace: $blktrace_command | $blkiomon_command | $zfcpdd_command";
-   $blktrace_command | $blkiomon_command | $zfcpdd_command > $WRP_MSG_Q_PATH/blktrace.log &
+   $blktrace_command 2>$WRP_MSG_Q_PATH/blktrace.err | $blkiomon_command | $zfcpdd_command > $WRP_MSG_Q_PATH/blktrace.log &
    i=0;
    # might take a moment to start all processes in the pipe if system under load
    while [ $i -lt 60 ]; do
@@ -288,27 +290,38 @@ function start_trace() {
       sleep 1;
       (( i++ ));
    done
-
    check_for_process $WRP_ZIOMON_MGR_PID;
-   [ $? -ne 0 ] && echo "Error: Failed to determine ziomon_mgr pid" && return 1;
+   [ $? -ne 0 ] && echo "$WRP_TOOLNAME: Failed to determine ziomon_mgr pid" && return 1;
    check_for_process $WRP_ZIOMON_UTIL_PID;
-   [ $? -ne 0 ] && echo "Error: Failed to determine ziomon_util pid" && return 1;
+   [ $? -ne 0 ] && echo "$WRP_TOOLNAME: Failed to determine ziomon_util pid" && return 1;
    check_for_process $WRP_BLKTRACE_PID;
-   [ "$WRP_BLKTRACE_PID" == "" ] && echo "Error: Failed to determine blktrace pid" && return 1;
+   [ $? -ne 0 ] && echo "$WRP_TOOLNAME: Failed to determine blktrace pid" && return 1;
    check_for_process $WRP_BLKIOMON_PID;
-   [ "$WRP_BLKIOMON_PID" == "" ] && echo "Error: Failed to determine blkiomon pid" && return 1;
+   [ $? -ne 0 ] && echo "$WRP_TOOLNAME: Failed to determine blkiomon pid" && return 1;
    check_for_process $WRP_ZIOMON_ZFCPDD_PID;
-   [ "$WRP_ZIOMON_ZFCPDD_PID" == "" ] && echo "Error: Failed to determine ziomon_zfcpdd pid" && return 1;
+   [ $? -ne 0 ] && echo "$WRP_TOOLNAME: Failed to determine ziomon_zfcpdd pid" && return 1;
 
    echo "done";
    echo -n "Collecting data...";
 
-   sleep $WRP_DURATION;
+   # pay extra attention to blktrace
+   for (( i=0; i<$WRP_DURATION; ++i )); do
+      len=`cat $WRP_MSG_Q_PATH/blktrace.err | wc -l`;
+      if [ $len -ne 0 ]; then
+         cat $WRP_MSG_Q_PATH/blktrace.err;
+         echo "Error: blktrace has errors, aborting";
+         return;
+      fi
+      sleep 1;
+   done
+
    echo "done";
 }
 
 
 function shutdown() {
+   local failed=0;
+
    echo "Shutting down";
    # one more second to write final result
    sleep 2;
@@ -332,6 +345,13 @@ function shutdown() {
          kill -s SIGTERM $WRP_ZIOMON_MGR_PID;
       fi
    fi
+   # kill running traces on devices
+   for dev in ${WRP_DEVICES[@]}; do
+      [ -d /sys/kernel/debug/block/${dev##*/} ] && debug "Trace on $dev exists, attempt to kill..." && blktrace -k $dev >/dev/null 2>&1;
+      [ -d /sys/kernel/debug/block/${dev##*/} ] && echo "$WRP_TOOLNAME: Failed to stop trace on $dev" && (( failed++ ));
+   done
+   [ $failed -ne 0 ] && echo "$WRP_TOOLNAME: blktrace has leftovers, manual cleanup required!";
+
    if [ -e $WRP_MSG_Q_PATH ]; then
       if [ $WRP_DEBUG -gt 1 ]; then
          debug "Logfiles available at $WRP_MSG_Q_PATH";
@@ -349,11 +369,28 @@ function emergency_shutdown() {
 }
 
 
+function check_cpuplugd {
+   # check if cpuplugd is running
+   # If so, the whole per-cpu mechanism of blktrace gets corrupted, which
+   # results in the infamous 'bad trace magic' message
+   if [ -e /var/run/cpuplugd.pid ]; then
+      echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
+      echo "ziomon: Warning: cpuplugd is running which can corrupt the traces.";
+      echo "        It is recommended to stop cpuplugd for the duration of the";
+      echo "        trace using 'service cpuplugd stop'.";
+      echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
+   fi
+}
+
+
 function setup() {
    while [ -e $WRP_MSG_Q_PATH ]; do
       WRP_MSG_Q_PATH="$WRP_MSG_Q_PATH$RANDOM";
    done
    mkdir $WRP_MSG_Q_PATH;
+   # check if debugfs is mounted (required for blktrace)
+   cat /proc/mounts | awk '{ print $3 }' | grep debugfs >/dev/null;
+   [ $? -ne 0 ] && echo "Error: No debugfs found. Mount debugfs and try again!" && exit 1;
 }
 
 
@@ -399,14 +436,14 @@ function check_for_multipath_devices() {
                devices_basenames[$j]="";
                clean_devices;
                (( i+=3 ));
-               while [ "${mp_arr[$i]:0:1}" == "_" ]; do
+               while [[ ! "${mp_arr[$i]:0:1}" =~ "[0-9a-zA-Z]" ]] && [ $i -lt ${#mp_arr[@]} ]; do
                   checked_devs[${#checked_devs[@]}]=`echo ${mp_arr[$i]} | awk '{print "/dev/"$3}'`;
                   ddebug "   add ${checked_devs[${#checked_devs[@]}-1]}";
-                  line=${mp_arr[$i]#_*};
+                  line=${mp_arr[$i]#* };
                   line=${line%%:*};
                   line=`echo $line | sed 's/ //g'`;
                   WRP_HOST_ADAPTERS[${#WRP_HOST_ADAPTERS[@]}]="host$line";
-                  WRP_LUNS[${#WRP_LUNS[@]}]=`echo ${mp_arr[$i]#_*} | awk '{print $1}'`;
+                  WRP_LUNS[${#WRP_LUNS[@]}]=`echo ${mp_arr[$i]#* } | awk '{print $1}'`;
                   (( i++ ));
                done;
                (( --i ));
@@ -464,7 +501,7 @@ function determine_host_adapters() {
    local num_s_devs;
    local s_dev_ratio;
 
-   echo -n "check devices...";
+   echo -n "Check devices...";
 
    # Estimate fraction of /dev/s* devices - if >50%, start with check for regular devices
    num_s_devs=`echo ${WRP_DEVICES[@]} | sed "s/ /\n/g" | grep /dev/s | wc -l`;
@@ -482,7 +519,7 @@ function determine_host_adapters() {
    for (( i=0; i<${#WRP_DEVICES[@]}; ++i )); do
       if [ "${WRP_DEVICES[$i]}" != "" ]; then
          if [ $found -eq 0 ]; then
-           echo "Error: The following devices do not seem to exist:";
+           echo "$WRP_TOOLNAME: The following devices do not seem to exist:";
            found=1;
          fi
          echo "   ${WRP_DEVICES[$i]}";
@@ -503,7 +540,7 @@ function determine_host_adapters() {
    debug "WRP_HOST_ADAPTERS: ${WRP_HOST_ADAPTERS[@]}";
 
    if [ ${#WRP_DEVICES[@]} -ne ${#WRP_LUNS[@]} ]; then
-      echo "Error: Number of LUNs does not match number of devices: ${#WRP_DEVICES[@]} devices and ${#WRP_LUNS[@]} LUNs.";
+      echo "$WRP_TOOLNAME: Number of LUNs does not match number of devices: ${#WRP_DEVICES[@]} devices and ${#WRP_LUNS[@]} LUNs";
       exit 2;
    fi
 }
@@ -522,13 +559,13 @@ function check_free_space_mileage() {
       (( history_percent = $limit * 100 / $estimated_size ));
       if [ $WRP_FORCE -eq 0 ] && [ $history_percent -lt $WRP_SIZE_THRESHOLD ]; then
          if [ "$WRP_SIZE" != "" ]; then
-            echo "Error: User-specified limit for log data too low.";
+            echo "$WRP_TOOLNAME: User-specified limit for log data too low";
             echo "Estimated maximum size of log data: $estimated_size MBytes.";
             echo "User-specified limit: $limit MBytes.";
             echo "This would equal $history_percent percent of the total data, while at least $WRP_SIZE_THRESHOLD percent is required.";
             echo "Either lower the duration, reduce the interval length, raise the limit or override using option '-f'."
          else
-            echo "Error: Not enough free disk space available for log data.";
+            echo "Error: Not enough free disk space available for log data";
             echo "Estimated maximum size of log data: $estimated_size MBytes.";
             echo "Free disk space available: $limit MBytes.";
             echo "This would equal $history_percent percent of the total data, while at least $WRP_SIZE_THRESHOLD percent is required.";
@@ -553,6 +590,28 @@ function check_free_space_mileage() {
 }
 
 
+function check_blktrace() {
+   which blktrace >/dev/null 2>&1;
+   if [ $? -ne 0 ]; then
+      echo "$WRP_TOOLNAME: Could not find blktrace. Please make sure that the blktrace package is installed and matches the level in the documentation.";
+      exit 1;
+   fi
+}
+
+
+function check_for_existing_output() {
+    # avoid config mismatch. Accidental deletion doesn't harm - can be recreated from .cfg anyway
+    if [ -e "$WRP_LOGFILE.config" ]; then
+        debug "$WRP_LOGFILE.config exists, removing";
+        rm -rf $WRP_LOGFILE.config;
+    fi
+    if [ -e "$WRP_LOGFILE.agg" ]; then
+        debug "$WRP_LOGFILE.agg exists, removing";
+        rm -rf $WRP_LOGFILE.agg;
+    fi
+}
+
+
 function check_size_requirements() {
    local util_base_sz;
    local util_variable_sz;
@@ -586,14 +645,13 @@ function check_size_requirements() {
    (( estimated_size=$total_num_records * $size_per_record ));
    debug "    estimated size: $estimated_size Bytes";
    (( estimated_size=$estimated_size / 1000000 ));
-   debug "    estimated size: $estimated_size MBytes";
    (( free_space = `df -k $logpath | tail -n 1 | awk '{print $4}'` / 1024 ));
    debug "    free space on '$logpath': $free_space MBytes";
    if [ "$WRP_SIZE" == "" ]; then
       echo "NOTE: No size limit specified, run without a limit.";
    else
       if [ $WRP_FORCE -eq 0 ] && [ $WRP_SIZE -gt $free_space ]; then
-         echo "Error: The user-specified limit of $WRP_SIZE MBytes for the log data exceeds the actual free space of $free_space MBytes.";
+         echo "$WRP_TOOLNAME: The user-specified limit of $WRP_SIZE MBytes for the log data exceeds the actual free space of $free_space MBytes.";
          echo "Either lower the limit, get more free space or use option '-f' to override.";
          return -1;
       fi
@@ -611,10 +669,16 @@ function check_size_requirements() {
 
 trap emergency_shutdown SIGHUP SIGTERM SIGINT SIGQUIT;
 
+check_blktrace;
+
 setup;
 
 parse_params $@;
 
+check_cpuplugd;
+
+check_for_existing_output;
+
 determine_host_adapters;
 
 check_size_requirements;
